TFCCApp.controller('loginController', ['$scope', '$rootScope', 'registerInstrumentService', 'serialNumberGenerator', '$location', 'Sqlite', 'CONSTANTS', function ($scope, $rootScope, registerInstrumentService, serialNumberGenerator, $location, Sqlite, CONSTANTS) {

    $scope.submitted = false;
    $scope.isFailedRegistration = false;
    $scope.clearError = true;

    $scope.registration = function () {
        var shell = require('electron').shell;
        event.preventDefault();
        shell.openExternal('https://login.thermofisher.com/mysso/loginDisplay');
    }
    $scope.forgotYourPasswd = function () {
        var shell = require('electron').shell;
        event.preventDefault();
        shell.openExternal('https://login.thermofisher.com/mysso/loginDisplay');
    }

    $scope.validateUser = function (isValid) {
        $scope.submitted = true;
        if (isValid) {
            // API call to register instrument which also validates user
            $scope.data1 = '';
            var data = {
                serialNumber: serialNumberGenerator.getSerialNumber(),
                type: CONSTANTS.TFCC_INSTRUMENT_TYPE,
                username: $scope.username,
                password: $scope.password
            };
            $scope.isRegistered = true;
            $scope.registerInstrumentResponse = registerInstrumentService.registerInstrument(data, function (successResponse, status) {
                $scope.successResponse = successResponse;
                $rootScope.username = successResponse.userFullName;
                Sqlite.initializeDataBase();
                Sqlite.insert(successResponse.principalId, successResponse.userFullName, successResponse.serialNumber, successResponse.instrumentId, successResponse.instrumentToken, successResponse.instrumentType);
                $location.path('/linkAccountSuccess');
            }, function (failureResponse) {
                $scope.failureResponse = failureResponse;
                $scope.isRegistered = false;
                $scope.isFailedRegistration = true;
                $scope.clearError = true;
            });
        }
    };

    $scope.clearWhenUserClicksIfError = function () {
        if (($scope.submitted) || ($scope.isFailedRegistration)) {
            $scope.clearError = false;
            $scope.isFailedRegistration = false;
        }
    }

}]);